package com.engine.organization.entity.scheme.param;

import com.engine.organization.common.BaseQueryParam;
import com.engine.organization.util.db.DBType;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;

/**
 * 薪资项目查询参数
 * <p>Copyright: Copyright (c) 2022</p>
 * <p>Company: 泛微软件</p>
 *
 * @author qiantao
 * @version 1.0
 **/
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
    public class SchemeSearchParam extends BaseQueryParam {

    //名称
    private String schemeNo;

    //备注
    private String schemeName;

    private String schemeDescription;

    private Integer forbiddenTag;



    public static String makeSqlWhere(SchemeSearchParam searchParam) {

        String sqlWhere = " 1 = 1 ";

        DBType dbType = DBType.get(new RecordSet().getDBType());

        String schemeNo = searchParam.getSchemeNo();
        if (StringUtils.isNotBlank(schemeNo)) {
            sqlWhere += " AND t.scheme_no " + dbType.like(schemeNo);
        }
        String schemeName = searchParam.getSchemeName();
        if (StringUtils.isNotBlank(schemeName)) {
            sqlWhere += " AND t.scheme_name " + dbType.like(schemeName);
        }
        String schemeDescription = searchParam.getSchemeDescription();
        if (schemeDescription != null) {
            sqlWhere += " AND t.scheme_description = " + schemeDescription;
        }
        Integer forbiddenTag = searchParam.getForbiddenTag();
        if (forbiddenTag != null) {
            sqlWhere += " AND t.forbidden_tag = " + forbiddenTag;
        }
        return sqlWhere;
    }
}
